#!/bin/bash

GREEN_COLOR='\033[0;32m'
NO_COLOR='\033[0m' # No Color
BASE_PACKAGE_PATH='./node_modules/generate-react-ts-code-base'

# install necessary package
echo -e "${GREEN_COLOR}Installing necessary package ...${NO_COLOR}"
(npm i -s axios @reduxjs/toolkit uuid redux react-redux redux-persist redux-persist/lib/storage react-router-dom lodash)
(npm i --save-dev env-cmd husky @types/uuid @types/lodash @types/react-router-dom lint-staged node-sass prettier pretty-quick)

if [ -f "./package.json" ]; then
  (npm run prepare)
fi


# copy all necessaries folders to build
echo -e "${GREEN_COLOR}Generate files & folers ...${NO_COLOR}"
if [ -f $BASE_PACKAGE_PATH ]; then
  (cd $BASE_PACKAGE_PATH && cp -R ./.vscode ./../../)
  (cd $BASE_PACKAGE_PATH && cp -R ./.husky ./../../)
  (cd $BASE_PACKAGE_PATH && cp -R ./env ./../../public)
  (cd $BASE_PACKAGE_PATH && cp -R ./src ./../../)
  (cd $BASE_PACKAGE_PATH && cp ./.editorconfig ./../../)
  (cd $BASE_PACKAGE_PATH && cp ./.env.development ./../../)
  (cd $BASE_PACKAGE_PATH && cp ./.env.production ./../../)
  (cd $BASE_PACKAGE_PATH && cp ./.env.testing ./../../)
  (cd $BASE_PACKAGE_PATH && cp ./.env.uat ./../../)
  (cd $BASE_PACKAGE_PATH && cp ./.prettierignore ./../../)
  (cd $BASE_PACKAGE_PATH && cp ./.prettierrc ./../../)
fi

echo -e "${GREEN_COLOR}❤️❤️❤️ DONE ❤️❤️❤️${NO_COLOR}"
echo -e "${GREEN_COLOR}Pls rate 1 star to https://github.com/trunghongoc/reactjs-ts-generate-base if it useful for you${NO_COLOR}"